package jogo;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

public class JogadorThread extends Thread {

    private Principal pai;
    private ObjectOutputStream saida;
    private ObjectInputStream entrada;
    private String IPSERVIDOR;
    private String nome;
    private int porta;
    private boolean id;
    private boolean conectado = false;

    public JogadorThread(Principal aThis, String nome, String IP, int porta, boolean id) {
        this.pai = aThis;
        this.nome = nome;
        this.IPSERVIDOR = IP;
        this.porta = porta;
        this.id = id;
    }

    public void enviarMensagem(Mensagem msg) {
        try {
            this.saida.writeObject(msg);
            System.err.println("JogadorThread, metodo enviarMensagem, id: " + this.id);
        } catch (IOException ex) {
            System.err.println("Erro ao enviar msg: " + ex.toString());
        }
    }

    @Override
    public void run() {
        Socket conexao;

        try {
            conexao = new Socket(IPSERVIDOR, porta);
            //obtendo os fluxos de entrada e de saida
            saida = new ObjectOutputStream(conexao.getOutputStream());
            entrada = new ObjectInputStream(conexao.getInputStream());

            this.conectado = true;

            Mensagem nomes = new Mensagem(15, this.nome);
            saida.writeObject(nomes);

            Mensagem recebida = null;

            while (conectado) {
                recebida = null;
                recebida = (Mensagem) entrada.readObject();
                switch (recebida.cod) {
                    case 15:
                        if (recebida.idJogador) {
                            this.pai.setgraficoNome1(this.nome);
                            this.pai.setgraficoNome2(recebida.corpo);
                        } else if (!recebida.idJogador) {
                            this.pai.setgraficoNome1(recebida.corpo);
                            this.pai.setgraficoNome2(this.nome);
                        }
                        //Mensagem novasCartas = new Mensagem(200,"");
                        //this.enviarMensagem(novasCartas);
                        break;

                    case 20:
                        this.pai.oponenteNegou();
                        break;

                    case 100: //iniciar cartas
                        this.pai.desenharBaralho(recebida.corpo, this.id);
                        break;

                    case 150:
                        this.pai.desenharCartaOponente(recebida.corpo, recebida.posCart_ou_truco);
                        break;

                    case 200:
                        this.pai.atualizaPlacar(recebida.rodada_ou_ganhadorpart, recebida.retornarResultado_ou_placar, this.id);
                        break;

                    case 250:
                        this.pai.terminarPartida(recebida.rodada_ou_ganhadorpart, recebida.retornarResultado_ou_placar, this.id);
                        break;

                    case 350:
                        this.pai.AumentarAposta(recebida.posCart_ou_truco);
                        break;

                    case 400:
                        this.pai.finalizarJogo(recebida.rodada_ou_ganhadorpart, recebida.retornarResultado_ou_placar, this.id);
                        break;
                }

            }

            // fechando os fluxos e a conexao
            saida.close();
            entrada.close();
            conexao.close();
        } catch (Exception ex) {
            System.err.println("Erro sockets JogadorThread: " + ex.toString());
            this.pai.desconectar1();
        }
    }

    public boolean getidJogador() {
        return this.id;
    }

    public void desconectar() {
        this.conectado = false;
    }
}
