package jogo;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;

public class ServidorThread extends Thread {

    private Principal pai;
    private Socket conexao;
    private ArrayList<ObjectOutputStream> outrosJogadores;
    private ArrayList<Mensagem> nomes;
    private ArrayList<String> baralho;
    private Random sementeAleatoria;
    private String manilha;

    public ServidorThread(Principal athis, Socket c, ArrayList<Mensagem> nomes, ArrayList<ObjectOutputStream> saidaDosJogadores) {
        this.pai = athis;
        this.conexao = c;
        this.outrosJogadores = saidaDosJogadores;
        this.nomes = nomes;
        this.sementeAleatoria = new Random();
        this.baralho = new ArrayList<String>();
    }

    public void criarCartas() {
        this.baralho.clear();
        String carta = null;
        String naipe = "oecp";
        String frente = "4567djq123";

        for (int f = 0; f < frente.length(); f++) {
            for (int n = 0; n < naipe.length(); n++) {
                carta = "" + frente.charAt(f) + naipe.charAt(n);
                this.baralho.add(carta);
            }
        }
        Collections.shuffle(this.baralho, this.sementeAleatoria);
        this.manilha = baralho.get(0);
        this.baralho.remove(0);
        this.pai.enviarManilhaComparador(manilha);
    }

    public String distribuirCartas() {
        String cartas = "";
        for (int n = 0; n < 3; n++) {
            if (n == 0) {
                cartas = "" + baralho.get(n);
            } else {
                cartas = "" + cartas + ":" + baralho.get(n);
            }
            baralho.remove(n);
        }
        cartas = "" + cartas + ":" + manilha;
        return cartas;
    }

    @Override
    public void run() {
        ObjectOutputStream saida;
        ObjectInputStream entrada;

        try {

            //obtendo os fluxos de entrada e de saida
            saida = new ObjectOutputStream(conexao.getOutputStream());
            entrada = new ObjectInputStream(conexao.getInputStream());

            //adiciona o fluxo de saida deste cliente no arraylist compatilhado
            //por todas as threads
            this.outrosJogadores.add(saida);

            boolean conectado = true;

            Mensagem nomeCliente = (Mensagem) entrada.readObject();
            // enviando o objeto Pessoa para o cliente

            if (nomeCliente.cod == 15) {
                this.nomes.add(nomeCliente);
                System.out.println(nomeCliente.corpo + " conectou no servidor...");

                if (this.outrosJogadores.size() == 2) {
                    this.outrosJogadores.get(0).writeObject(new Mensagem(15, nomes.get(1).corpo, true)); //primeiro jogador
                    this.outrosJogadores.get(1).writeObject(new Mensagem(15, nomes.get(0).corpo, false)); //segundo jogador

                    //Enquanto o jogo nao conter 2 jogadores, o baralho nao e criado
                    this.criarCartas();

                    for (ObjectOutputStream outraSaida : outrosJogadores) {

                        String cartas = this.distribuirCartas();
                        outraSaida.writeObject(new Mensagem(100, cartas));
//////////////////////////////////////////////////////////////////////////////////
                        System.err.println("ServidorThread, cartas :" + cartas);
//////////////////////////////////////////////////////////////////////////////////
                    }
                }
            }

            Mensagem recebida = null;

            while (conectado) {

                //int enviar = 0;
                recebida = null;
                recebida = (Mensagem) entrada.readObject();

                switch (recebida.cod) {
                    case 10: //desconexao

                        break;

                    case 20: //desconexao
                        for (ObjectOutputStream outraSaida : outrosJogadores) {
                            if(saida != outraSaida){
                                outraSaida.writeObject(new Mensagem(20, ""));
                            }
                        }
                        break;

                    case 100://iniciar cartas no inicio do jogo/partida
                        for (ObjectOutputStream outraSaida : outrosJogadores) {

                            String cartas = this.distribuirCartas();
                            outraSaida.writeObject(new Mensagem(100, cartas));
                        }
                        break;

                    case 150: //envia carta para o oponente
                        this.pai.comparar(recebida.corpo, recebida.idJogador);////////////////////////////////////
                        for (ObjectOutputStream outraSaida : this.outrosJogadores) {
                            if (saida != outraSaida) {
                                //enviando a carta para o adversario
                                outraSaida.writeObject(new Mensagem(150, recebida.corpo, recebida.posCart_ou_truco, recebida.idJogador));
                            }
                        }

                        if (!this.pai.getExecutado()) {
                            for (ObjectOutputStream outrasaida : this.outrosJogadores) {
                                outrasaida.writeObject(new Mensagem(200, this.pai.getRodada(), this.pai.retornarResultado()));
                            }
                        }

                        if (this.pai.getNaoPermitirRodada()) {
                            for (ObjectOutputStream outrasaida : this.outrosJogadores) {
                                if (this.pai.getPlacar() >= 12) {
                                    outrasaida.writeObject(new Mensagem(400, this.pai.getGanhador(), this.pai.getPlacar()));
                                } else {
                                    outrasaida.writeObject(new Mensagem(200, this.pai.getRodada(), this.pai.retornarResultado()));
                                    outrasaida.writeObject(new Mensagem(250, this.pai.getGanhador(), this.pai.getPlacar()));
                                }

                            }
                        }
                        break;


                    //final de uma partida, comeca outra
                    case 300:
                        if (!this.pai.getEnviar()) {
                            this.pai.setEnviar(true);
                        } else if (this.pai.getEnviar()) {
                            this.pai.setEnviar(false);
                            this.pai.setarVariaveis();
                            this.criarCartas();
                            String cartas = this.distribuirCartas();
                            this.outrosJogadores.get(0).writeObject(new Mensagem(100, cartas));
                            cartas = this.distribuirCartas();
                            this.outrosJogadores.get(1).writeObject(new Mensagem(100, cartas));
                        }
                        break;


                    case 350:
                        for (ObjectOutputStream outraSaida : this.outrosJogadores) {
                            if (saida != outraSaida) {
                                outraSaida.writeObject(new Mensagem(350, recebida.posCart_ou_truco, recebida.idJogador));
                            }
                        }
                        break;

                    case 351:
                        this.pai.podeApostar(recebida.posCart_ou_truco, recebida.idJogador);


                        //if(true) {
                        for (ObjectOutputStream outraSaida : this.outrosJogadores) {
                            if (saida != outraSaida) {
                                outraSaida.writeObject(new Mensagem(350, recebida.posCart_ou_truco, recebida.idJogador));
                            }
                        }
                        if (this.pai.correr()) {
                            if (this.pai.getPlacar() < 12) {
                                this.outrosJogadores.get(0).writeObject(new Mensagem(250, this.pai.getGanhador(), this.pai.getPlacar()));
                                this.outrosJogadores.get(1).writeObject(new Mensagem(250, this.pai.getGanhador(), this.pai.getPlacar()));
                            } else if (this.pai.getPlacar() >= 12) {
                                this.outrosJogadores.get(0).writeObject(new Mensagem(400, this.pai.getGanhador(), this.pai.getPlacar()));
                                this.outrosJogadores.get(1).writeObject(new Mensagem(400, this.pai.getGanhador(), this.pai.getPlacar()));
                            }

                        }
                        break;
                }
                if (!conectado) {
                    // fechando os fluxos e a conexao
                    saida.close();
                    entrada.close();
                    this.conexao.close();
                }
            }




        } catch (Exception ex) {
            System.err.println("Erro sockets ServidorThread: " + ex.toString());
            this.pai.desconectar2();
        }

    }
}
